#define max_vertices 64000 // Max number of vertices (for each object)
#define max_polygons 64000 // Max number of polygons (for each object)
#define max_textures 64000 // Max number of textures (for each object)
#define max_obj 200

int test=0,test1=0,size=0;
// Our vertex type
typedef struct{
    float x,y,z;
}vertex_type;

// The polygon (triangle), 3 numbers that aim 3 vertices
typedef struct{
    int a,b,c,flags;
}polygon_type;

// The mapcoord type, 2 texture coordinates for each vertex
typedef struct{
    float u,v;
}mapcoord_type;

// The object type
typedef struct {
    char name[max_obj][200];
    int obj_poly[max_obj];
    char$ prefix$;
    
    int vertices_qty;
    int polygons_qty;
    int textures_qty;

    vertex_type vertex[max_vertices];
    polygon_type polygon[max_polygons];
    mapcoord_type mapcoord[max_textures];
    //int id_texture;
} obj_type;//, *obj_type_ptr;

/**********************************************************
 *
 * FUNCTION Load3DS (obj_type_ptr, char *)
 *
 * This function loads a mesh from a 3ds file.
 * Please note that we are loading only the vertices, polygons and mapping lists.
 * If you need to load meshes with advanced features as for example: 
 * multi objects, materials, lights and so on, you must insert other chunk parsers.
 *
 *********************************************************/

//int Load3DSobj (obj_type_ptr p_object, char *p_filename)
int Load3DSobj (obj_type *p_object, char *p_filename)
{
	test1=test;char* aux$="                 ";
    int i=0,j=0; //Index variable
	char$ prefix$;prefix$=instrrev$(p_filename,'\\');prefix$=leftc$(prefix$,len(prefix$)-4);
	p_object->prefix$=wordc$(prefix$,1);if(test==1){notice(strc$("prefix$=",prefix$));}
	
	FILE *l_file; //File pointer
	
	unsigned short l_chunk_id; //Chunk identifier
	unsigned int l_chunk_lenght; //Chunk lenght

	unsigned char l_char; //Char variable
	unsigned short l_qty; //Number of elements in each chunk

	unsigned short l_face_flags; //Flag that stores some face information

	if ((l_file=fopen (p_filename, "rb"))== NULL) return 0; //Open the file
    int filelen;filelen=filelength (fileno (l_file)); 
	int v0=0,p0=0,t0=0,nvertex=0,npoly=0,ntext=0;//offsets
    int obj=-1;
    while (ftell(l_file)<filelen and ftell(l_file)>=0 ) //Loop to scan the whole file 
	{
		//getche(); //Insert this command for debug (to wait for keypress for each chuck reading)

		fread (&l_chunk_id, 2, 1, l_file); //Read the chunk header
		//printf("ChunkID: %x\n",l_chunk_id); 
		fread (&l_chunk_lenght, 4, 1, l_file); //Read the lenght of the chunk
		//printf("ChunkLenght: %x\n",l_chunk_lenght);

		switch (l_chunk_id)
        {
			//----------------- MAIN3DS -----------------
			// Description: Main chunk, contains all the other chunks
			// Chunk ID: 4d4d 
			// Chunk Lenght: 0 + sub chunks
			//-------------------------------------------
			case 0x4d4d: 
			break;    

			//----------------- EDIT3DS -----------------
			// Description: 3D Editor chunk, objects layout info 
			// Chunk ID: 3d3d (hex)
			// Chunk Lenght: 0 + sub chunks
			//-------------------------------------------
			case 0x3d3d:
			break;
			
			//--------------- EDIT_OBJECT ---------------
			// Description: Object block, info for each object
			// Chunk ID: 4000 (hex)
			// Chunk Lenght: len(object name) + sub chunks
			//-------------------------------------------
			case 0x4000: 
				if(obj<(max_obj-2)){++obj;}
                i=0;
				do
				{
					fread (&l_char, 1, 1, l_file);
                    p_object->name[obj][i]=l_char;
					i++;
                }while(l_char != '\0' && i<200);
                p_object->obj_poly[obj]=npoly;
            if(test1==1){confirm(strc$("objet$=",p_object->name[obj]),aux$);//MessageBox(0,p_object->name[obj],"nom objet",0);}
			             if(!strcmp(aux$,"no")){test1=0;} }    
            break;

			//--------------- OBJ_TRIMESH ---------------
			// Description: Triangular mesh, contains chunks for 3d mesh info
			// Chunk ID: 4100 (hex)
			// Chunk Lenght: 0 + sub chunks
			//-------------------------------------------
			case 0x4100:
			break;
			
			//--------------- TRI_VERTEXL ---------------
			// Description: Vertices list
			// Chunk ID: 4110 (hex)
			// Chunk Lenght: 1 x unsigned short (number of vertices) 
			//             + 3 x float (vertex coordinates) x (number of vertices)
			//             + sub chunks
			//-------------------------------------------
			case 0x4110: 
				fread (&l_qty, sizeof (unsigned short), 1, l_file);
                //printf("Number of vertices: %d\n",l_qty);
                for (i=0; i<l_qty; i++)
                {
					j=min(max_vertices-1,i+nvertex);
                    fread (&p_object->vertex[j].x, sizeof(float), 1, l_file);
 					//printf("Vertices list x: %f\n",p_object->vertex[i].x);
                    fread (&p_object->vertex[j].y, sizeof(float), 1, l_file);
 					//printf("Vertices list y: %f\n",p_object->vertex[i].y);
					fread (&p_object->vertex[j].z, sizeof(float), 1, l_file);
 					//printf("Vertices list z: %f\n",p_object->vertex[i].z);
				}
				v0=nvertex;
                nvertex = min(max_vertices,nvertex+l_qty);
                //MessageBox(0,"vertex data","load info",0);
                //if(test1==1){notice(strc$("vertex data nvertex=",str$(nvertex)));}
                break;

			//--------------- TRI_FACEL1 ----------------
			// Description: Polygons (faces) list
			// Chunk ID: 4120 (hex)
			// Chunk Lenght: 1 x unsigned short (number of polygons) 
			//             + 3 x unsigned short (polygon points) x (number of polygons)
			//             + sub chunks
			//-------------------------------------------
			case 0x4120:
				fread (&l_qty, sizeof (unsigned short), 1, l_file);
                //printf("Number of polygons: %d\n",l_qty); 
                unsigned short ifile;
                for (i=0; i<l_qty; i++)
                {
 					j=min(max_polygons-1,i+npoly);
                   fread (&ifile, sizeof (unsigned short), 1, l_file);
					p_object->polygon[j].a=min(max_vertices-1,ifile+v0);
					 //printf("Polygon point a: %d\n",p_object->polygon[i].a);
                    fread (&ifile, sizeof (unsigned short), 1, l_file);
					p_object->polygon[j].b=min(max_vertices-2,ifile+v0);
					//printf("Polygon point b: %d\n",p_object->polygon[i].b);
                    fread (&ifile, sizeof (unsigned short), 1, l_file);
					p_object->polygon[j].c=min(max_vertices-3,ifile+v0);
					//printf("Polygon point c: %d\n",p_object->polygon[i].c);
					fread (&l_face_flags, sizeof (unsigned short), 1, l_file);
					p_object->polygon[j].flags=l_face_flags;
					//printf("Face flags: %x\n",l_face_flags);
				}
                p0=npoly;
                npoly = min(max_polygons,npoly+l_qty);
                break; 

			//------------- TRI_MAPPINGCOORS ------------
			// Description: Vertices list
			// Chunk ID: 4140 (hex)
			// Chunk Lenght: 1 x unsigned short (number of mapping points) 
			//             + 2 x float (mapping coordinates) x (number of mapping points)
			//             + sub chunks
			//-------------------------------------------
			case 0x4140:
				fread (&l_qty, sizeof (unsigned short), 1, l_file);
                for (i=0; i<l_qty; i++)
				{
                   j=min(max_textures-1,i+ntext);
                   fread (&p_object->mapcoord[j].u, sizeof (float), 1, l_file);
					//printf("Mapping list u: %f\n",p_object->mapcoord[i].u);
                   fread (&p_object->mapcoord[j].v, sizeof (float), 1, l_file);
					//printf("Mapping list v: %f\n",p_object->mapcoord[i].v);
				}
                t0=ntext;
                ntext = min(max_textures,ntext+l_qty);
                break;

			//----------- Skip unknow chunks ------------
			//We need to skip all the chunks that currently we don't use
			//We use the chunk lenght information to set the file pointer
			//to the same level next chunk
			//-------------------------------------------
			default:
				 fseek(l_file, l_chunk_lenght-6, SEEK_CUR);
        } 
	}
	fclose (l_file); // Closes the file stream
	++obj;p_object->obj_poly[obj]=9999999;
    p_object->vertices_qty =nvertex;
    p_object->polygons_qty =npoly; 
    p_object->textures_qty =ntext;
    return (1); // Returns ok
}

void msgobjet(obj_type * object) {
    int v;v=(int)object->vertices_qty;
    int p;p=(int)object->polygons_qty;
    int t;t=(int)object->textures_qty;
    char a$[]="                                         ";
    itoa(v,a$,10);
    MessageBox(0,a$,"nbre vertices",0);
    itoa(p,a$,10);
    MessageBox(0,a$,"nbre polygons",0);
    itoa(t,a$,10);
    MessageBox(0,a$,"nbre textures",0);
}

void drawobj(obj_type * object,char* textlist$,char* defauttex$)
{
    int l_index,vn,v;
    float x1,y1,z1,x2,y2,z2,x3,y3,z3,vx1,vy1,vz1,vx2,vy2,vz2,vx3,vy3,vz3;
    float vmax=0.001,kk;
    int obj=0,obj_poly=object->obj_poly[obj],itext=0;
    char$ obj$,text0$,prefix$;obj$=object->name[obj];prefix$=object->prefix$;
    char* text$;text$=textlist$;char* aux$="               ";int test1=test;
    if(test1==1){notice(strc$("obj$=",obj$," textlist$=",text$));}
    
    if (size>0){
    for (v=1;v<=object->vertices_qty;v++)
    { 
        vmax=max(vmax,0.5*vmax+0.5*fabs(object->vertex[v].x));
        vmax=max(vmax,0.5*vmax+0.5*fabs(object->vertex[v].y));
        vmax=max(vmax,0.5*vmax+0.5*fabs(object->vertex[v].z));
    };
    kk=size/vmax; }else{kk=1;};

    glBegin(GL_TRIANGLES); // glBegin and glEnd delimit the vertices that define a primitive (in our case triangles)
    for (l_index=0;l_index<object->polygons_qty;l_index++)
    {
        if(l_index>=obj_poly){while(l_index>=obj_poly and obj<max_obj)
                                {++obj;obj_poly=object->obj_poly[obj];}
                              obj$=char$(strc$(prefix$,object->name[obj-1]));
                              text$=textlist$;text0$=firstwordc$(text$);
                              if(test1==1){confirm(strc$("obj$=",obj$," textlist$=",text$),aux$);
                                          if(!strcmp(aux$,"no")){test1=0;} }
                              while(text0$[0]!=0 and obj$!=text0$){text$=nextwordc$(text$);
                                                                   text$=nextwordc$(text$);
                                                                   text0$=firstwordc$(text$);}
                              if(obj$==text0$){text$=nextwordc$(text$);
                                               text0$=firstwordc$(text$);itext=val(text0$);
                                               if(test==1){
                                               notice(strc$("bindtext=",obj$," itext=",str$(itext)));
                                                }
                                               glEnd();
                                               if(itext>0){glBindTexture(GL_TEXTURE_2D,itext);}
                                               glBegin(GL_TRIANGLES);}
                              else{
                              text$=textlist$;text0$=firstwordc$(text$);obj$=defauttex$;
                              if(test1==1){confirm(strc$("obj$=",obj$," textlist$=",text$),aux$);
                                          if(!strcmp(aux$,"no")){test1=0;} }
                              while(text0$[0]!=0 and obj$!=text0$){text$=nextwordc$(text$);
                                                                   text$=nextwordc$(text$);
                                                                   text0$=firstwordc$(text$);}
                              if(obj$==text0$){text$=nextwordc$(text$);
                                               text0$=firstwordc$(text$);itext=val(text0$);
                                               if(test1==1){
                                               notice(strc$("bindtext=",obj$," itext=",str$(itext)));
                                                }
                                               glEnd();
                                               if(itext>0){glBindTexture(GL_TEXTURE_2D,itext);}
                                               glBegin(GL_TRIANGLES);}
                                   
                                   }                 
                              }


                  {vn=object->polygon[l_index].a; x1=object->vertex[vn].x; y1=object->vertex[vn].y; z1=object->vertex[vn].z;
                   vn=object->polygon[l_index].b; x2=object->vertex[vn].x; y2=object->vertex[vn].y; z2=object->vertex[vn].z;
                   vn=object->polygon[l_index].c; x3=object->vertex[vn].x; y3=object->vertex[vn].y; z3=object->vertex[vn].z;
                   vx1=x2-x1; vy1=y2-y1; vz1=z2-z1;
                   vx2=x3-x1; vy2=y3-y1; vz2=z3-z1;
                   vx3=(vz2*vy1)-(vy2*vz1);
                   vy3=(vx2*vz1)-(vz2*vx1);
                   vz3=(vy2*vx1)-(vx2*vy1);
                   glNormal3f(vx3,vy3,vz3); };                     
                                                                                   
        //----------------- FIRST VERTEX -----------------
        // Texture coordinates of the first vertex
        glTexCoord2f( object->mapcoord[ object->polygon[l_index].a ].u,
                      object->mapcoord[ object->polygon[l_index].a ].v);
        // Coordinates of the first vertex
        glVertex3f( object->vertex[ object->polygon[l_index].a].x*kk,
                    object->vertex[ object->polygon[l_index].a ].y*kk,
                    object->vertex[ object->polygon[l_index].a ].z*kk); //Vertex definition

        //----------------- SECOND VERTEX -----------------
        // Texture coordinates of the second vertex
        glTexCoord2f( object->mapcoord[ object->polygon[l_index].b ].u,
                      object->mapcoord[ object->polygon[l_index].b ].v);
        // Coordinates of the second vertex
        glVertex3f( object->vertex[ object->polygon[l_index].b].x*kk,
                    object->vertex[ object->polygon[l_index].b ].y*kk,
                    object->vertex[ object->polygon[l_index].b ].z*kk); //Vertex definition

        //----------------- THIRD VERTEX -----------------
        // Texture coordinates of the third vertex
        glTexCoord2f( object->mapcoord[ object->polygon[l_index].c ].u,
                      object->mapcoord[ object->polygon[l_index].c ].v);
        // Coordinates of the Third vertex
        glVertex3f( object->vertex[ object->polygon[l_index].c].x*kk,
                    object->vertex[ object->polygon[l_index].c ].y*kk,
                    object->vertex[ object->polygon[l_index].c ].z*kk); //Vertex definition
    }
    glEnd();
}

void drawobj2(obj_type * object)
{
    int l_index;
    
    glBegin(GL_TRIANGLES); // glBegin and glEnd delimit the vertices that define a primitive (in our case triangles)
    for (l_index=0;l_index<object->polygons_qty;l_index++)
    {
        //----------------- FIRST VERTEX -----------------
        // Texture coordinates of the first vertex
        glTexCoord2f( object->vertex[ object->polygon[l_index].a ].x,
                      object->vertex[ object->polygon[l_index].a ].y);
        // Coordinates of the first vertex
        glVertex3f( object->vertex[ object->polygon[l_index].a].x,
                    object->vertex[ object->polygon[l_index].a ].y,
                    object->vertex[ object->polygon[l_index].a ].z); //Vertex definition

        //----------------- SECOND VERTEX -----------------
        // Texture coordinates of the second vertex
        glTexCoord2f( object->vertex[ object->polygon[l_index].b ].x,
                      object->vertex[ object->polygon[l_index].b ].y);
        // Coordinates of the second vertex
        glVertex3f( object->vertex[ object->polygon[l_index].b].x,
                    object->vertex[ object->polygon[l_index].b ].y,
                    object->vertex[ object->polygon[l_index].b ].z); //Vertex definition

        //----------------- THIRD VERTEX -----------------
        // Texture coordinates of the third vertex
         glTexCoord2f( object->vertex[ object->polygon[l_index].c ].x,
                       object->vertex[ object->polygon[l_index].c ].y);
       // Coordinates of the Third vertex
        glVertex3f( object->vertex[ object->polygon[l_index].c].x,
                    object->vertex[ object->polygon[l_index].c ].y,
                    object->vertex[ object->polygon[l_index].c ].z); //Vertex definition
    }
    glEnd();
}
